/*
Copyright 2022 Rancher Labs, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	rkecattleiov1 "github.com/rancher/rancher/pkg/apis/rke.cattle.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRKEBootstrapTemplates implements RKEBootstrapTemplateInterface
type FakeRKEBootstrapTemplates struct {
	Fake *FakeRkeV1
	ns   string
}

var rkebootstraptemplatesResource = schema.GroupVersionResource{Group: "rke.cattle.io", Version: "v1", Resource: "rkebootstraptemplates"}

var rkebootstraptemplatesKind = schema.GroupVersionKind{Group: "rke.cattle.io", Version: "v1", Kind: "RKEBootstrapTemplate"}

// Get takes name of the rKEBootstrapTemplate, and returns the corresponding rKEBootstrapTemplate object, and an error if there is any.
func (c *FakeRKEBootstrapTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *rkecattleiov1.RKEBootstrapTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(rkebootstraptemplatesResource, c.ns, name), &rkecattleiov1.RKEBootstrapTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrapTemplate), err
}

// List takes label and field selectors, and returns the list of RKEBootstrapTemplates that match those selectors.
func (c *FakeRKEBootstrapTemplates) List(ctx context.Context, opts v1.ListOptions) (result *rkecattleiov1.RKEBootstrapTemplateList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(rkebootstraptemplatesResource, rkebootstraptemplatesKind, c.ns, opts), &rkecattleiov1.RKEBootstrapTemplateList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &rkecattleiov1.RKEBootstrapTemplateList{ListMeta: obj.(*rkecattleiov1.RKEBootstrapTemplateList).ListMeta}
	for _, item := range obj.(*rkecattleiov1.RKEBootstrapTemplateList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested rKEBootstrapTemplates.
func (c *FakeRKEBootstrapTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(rkebootstraptemplatesResource, c.ns, opts))

}

// Create takes the representation of a rKEBootstrapTemplate and creates it.  Returns the server's representation of the rKEBootstrapTemplate, and an error, if there is any.
func (c *FakeRKEBootstrapTemplates) Create(ctx context.Context, rKEBootstrapTemplate *rkecattleiov1.RKEBootstrapTemplate, opts v1.CreateOptions) (result *rkecattleiov1.RKEBootstrapTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(rkebootstraptemplatesResource, c.ns, rKEBootstrapTemplate), &rkecattleiov1.RKEBootstrapTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrapTemplate), err
}

// Update takes the representation of a rKEBootstrapTemplate and updates it. Returns the server's representation of the rKEBootstrapTemplate, and an error, if there is any.
func (c *FakeRKEBootstrapTemplates) Update(ctx context.Context, rKEBootstrapTemplate *rkecattleiov1.RKEBootstrapTemplate, opts v1.UpdateOptions) (result *rkecattleiov1.RKEBootstrapTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(rkebootstraptemplatesResource, c.ns, rKEBootstrapTemplate), &rkecattleiov1.RKEBootstrapTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrapTemplate), err
}

// Delete takes name of the rKEBootstrapTemplate and deletes it. Returns an error if one occurs.
func (c *FakeRKEBootstrapTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(rkebootstraptemplatesResource, c.ns, name, opts), &rkecattleiov1.RKEBootstrapTemplate{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRKEBootstrapTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(rkebootstraptemplatesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &rkecattleiov1.RKEBootstrapTemplateList{})
	return err
}

// Patch applies the patch and returns the patched rKEBootstrapTemplate.
func (c *FakeRKEBootstrapTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *rkecattleiov1.RKEBootstrapTemplate, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(rkebootstraptemplatesResource, c.ns, name, pt, data, subresources...), &rkecattleiov1.RKEBootstrapTemplate{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrapTemplate), err
}
